﻿using System;
using System.Collections.Generic;
using System.ComponentModel;


namespace InfragisticsTest
{
  class DataPropertyDescriptor:PropertyDescriptor 
  {
    public DataPropertyDescriptor(string name)
      : base(name, new Attribute[0])
    {
    }

    public DataPropertyDescriptor(string name, Attribute[] attrs) : base(name, attrs)
    {
    }

    public DataPropertyDescriptor(MemberDescriptor descr) : base(descr)
    {
    }

    public DataPropertyDescriptor(MemberDescriptor descr, Attribute[] attrs) : base(descr, attrs)
    {

    }

    public override bool CanResetValue(object component)
    {
      return true;
    }

    public override object GetValue(object component)
    {
      Person person = component as Person;
      switch(Name)
      {
        case "First Name":
          return person.FirstName;
        case "Last Name":
          return person.LastName;
        case "Children":
          if (person is Parent)
          {
            return ((Parent) person).Children;
          }
          return null;
        default:
          return null;
      }
    }

    public override void ResetValue(object component)
    {
     
    }

    public override void SetValue(object component, object value)
    {
    }

    public override bool ShouldSerializeValue(object component)
    {
      return false;
    }

    public override Type ComponentType
    {
      get
      {
        return typeof (Person);  
      }
    }

    public override bool IsReadOnly
    {
      get { return true;}
    }

    public override Type PropertyType
    {
      get {
        switch (Name)
        {
          case "First Name":
            return typeof (string);
          case "Last Name":
            return typeof (string);
          case "Children":
            return typeof(PersonList);
          default:
            return null;
        } 
      }
    }
  }
}
