﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;

namespace InfragisticsTest
{
  public partial class Form1 : Form
  {
    private PersonList _originalList;
    public Form1()
    {
      Person _jacob = new Person();
      _jacob.FirstName = "Jacob";
      _jacob.LastName = "Israel";
       _originalList = new PersonList();
      _jacob.ParentList = _originalList;
      _originalList.Add(_jacob);
      InitializeComponent();
      _grid.DataSource = _originalList;
      _originalList.ListChanged += new System.ComponentModel.ListChangedEventHandler(_originalList_ListChanged);
    }

    void _originalList_ListChanged(object sender, System.ComponentModel.ListChangedEventArgs e)
    {
      if (e.ListChangedType == ListChangedType.PropertyDescriptorChanged ||
        e.ListChangedType == ListChangedType.PropertyDescriptorDeleted ||
        e.ListChangedType == ListChangedType.PropertyDescriptorAdded)
      {
        _bandsNow.Text = _grid.DisplayLayout.Bands.All.Length + " " + _bandsNow.Text;  
      }
    }

    private void _btnReproduce_Click(object sender, System.EventArgs e)
    {

    
      int num = int.Parse(_txbGens.Text);

      for (int i = 0; i < num; i++)
      {
        PersonList pl = new PersonList();
        PersonList.Depth++;
        pl.AddRange(_originalList);
        foreach (Person person in pl)
        {
          Reproduce(person);
        }
        _originalList.FireListChanged(_originalList);
      }
      _originalList.FireListChanged(_originalList);
    }

    /// <summary>
    /// Goes to the most buttom level and adds children
    /// </summary>
    /// <param name="node"></param>
    private void Reproduce(Person node)
    {
      Parent parent = node as Parent;
      if (parent != null)
      {
        PersonList pl = new PersonList();
        pl.AddRange(parent.Children);
        foreach (Person person in pl)
        {
          Reproduce(person);
        }
      }
      else
      {
        Parent newParent = new Parent(node);
        for (int i = 0; i < 2; i++)
        {
          Person p = new Person();
          p.FirstName = node.FirstName + i;
          p.LastName = node.LastName + " ibn " + node.FirstName;
          newParent.Children.Add(p);
          p.ParentList = newParent.Children;
        }
        //newParent.ParentList.FireListAdded(newParent.ParentList);
      }
    }

   
    private void _btnDie_Click(object sender, System.EventArgs e)
    {
      int num = int.Parse(_txbGens.Text);
      Die(num);
    }



    /// <summary>
    /// Removes num top levels from the tree
    /// </summary>
    /// <param name="num"></param>
    private void Die(int num)
    {
      for(int i=0;i<num;i++)
      {
        PersonList.Depth--;
        Die();
        _originalList.FireListChanged(_originalList);
        //CallRemoveEveryWhere(_originalList);
      }
    }

    void CallRemoveEveryWhere(PersonList parentList_)
    {
      
      if(!(parentList_[0] is Parent))
      {
        parentList_.FireListChanged(_originalList);
      }
      foreach (Person person in parentList_)
      {
        Parent parent = person as Parent;
        if(parent!=null)
        {
          CallRemoveEveryWhere(parent.Children);
        }
      }

    }

    /// <summary>
    /// Removes a top level of parents from the structure
    /// </summary>
    private void Die()
    {
      if(PersonList.Depth<=0)
        return;


      PersonList personList=new PersonList();
      personList.AddRange(_originalList);
      _originalList.Clear();
      foreach (Person p in personList)
      {
        Parent parent = p as Parent;
        if (parent != null)
        {
          foreach (Person person in parent.Children)
          {
            person.ParentList = _originalList;
            _originalList.Add(person);
          }
        }
        else
        {
          _originalList.Add(p);
        }
      }
    }
  }
}
